/* Copyright 1996, Jan D. Wolter and Steven R. Weiss, All Rights Reserved. */

char *firstusr(void);
char *nextusr(void);
char *gethomedir(char *);

#ifdef UD_PASSWD

extern struct passwd *last_pw;

#ifndef PASSWD_FILE

                /* ---------- Real passwd file -------- */

struct passwd *getdbnam(char *n);
void flushusercache(void);
#define getdbuid(u) (last_pw= getpwuid(u))
#define firstdb() (setpwent(),last_pw= getpwent())
#define nextdb() (last_pw= getpwent())

#else /* PASSWD_FILE */

                /* ---------- fake passwd-like file --------- */

#ifdef NOFGETPWENT
struct passwd *fgetpwent(FILE *fp);
#endif

struct passwd *getpwnu(char *nam, uid_t uid);
#define getdbnam(n) getpwnu(n,-1)
#define getdbuid(u) getpwnu(NULL,u)
extern FILE *dbfp;
void resetpw(void);
#define firstdb() (resetpw(),last_pw= fgetpwent(dbfp))
#define nextdb() (last_pw= fgetpwent(dbfp))
void flushusercache(void);

#endif /* PASSWD_FILE */
#else /* !UD_PASSWD */
#ifdef UD_DBM

                      /* ----------- dbm database ----------- */

struct passwd *getdbnam(char *nam);
#if defined(ID_GETUID) && defined(UID_MAP_FILE) && defined(DBM_UID_FILE)
struct passwd *getdbuid(uid_t uid);
#endif
#define firstdb() getdbnam(firstusr())
#define nextdb() getdbnam(nextusr())
#define flushusercache()

#else /* ! UD_DBM */
#ifdef UD_TAGFILE

                /* ---------- tagfiles in user directories -------- */

/* We don't define getdbuid() because it doesn't work with tagfiles. */
struct passwd *getdbnam(char *nam);
#define firstdb() getdbnam(firstusr())
#define nextdb() getdbnam(nextusr())
#define flushusercache()

#endif /* UD_TAGFILE*/
#endif /* ! UD_DBM */
#endif /* ! UD_PASSWD */


#if defined(ID_GETUID) && defined(UID_MAP_FILE)
char *mapuid(uid_t uid);
#endif

char *getpassword(char *nam);
